﻿Imports C1.Win.C1Chart

Public Class Form1
    Public Sub New()

        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.

    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        InitChart()
    End Sub
    Private Sub InitChart()
        Dim grp0 = C1Chart1.ChartGroups.Group0
        grp0.ChartData.SeriesList.Clear()

        grp0.ChartType = C1.Win.C1Chart.Chart2DTypeEnum.Gantt
        Dim Data = GetData()
        For Each item In Data
            Dim ser = grp0.ChartData.SeriesList.AddNewSeries()
            ser.Label = item.Task
            ser.Y.CopyDataIn(New DateTime() {item.StartTime})
            ser.Y1.CopyDataIn(New DateTime() {item.EndTime})
        Next

        C1Chart1.ChartArea.Inverted = True
        C1Chart1.ChartArea.AxisX.Reversed = True

        Dim startDate = New DateTime(Data.First().StartTime.Year, Data.First().StartTime.Month, Data.First().StartTime.Day, 8, 0, 0)
        Dim endDate = New DateTime(Data.Last().EndTime.Year, Data.Last().EndTime.Month, Data.Last().EndTime.Day, 18, 0, 0)


        C1Chart1.ChartArea.AxisY.Min = startDate.ToOADate()
        C1Chart1.ChartArea.AxisY.Max = endDate.ToOADate()
        C1Chart1.ChartArea.AxisY.AutoMinor = False

        '
        'Use the following for default Short Time labels: e.g :    8:00 9:00 10:00 etc.
        '
        C1Chart1.ChartArea.AxisY.AnnoFormat = C1.Win.C1Chart.FormatEnum.DateShortTime
        C1Chart1.ChartArea.AxisY.UnitMajor = 0.05 'For 1 hour gap between labels

        ' ------------------------ Or -------------------------------------------------
        'Use the following for custom time labels: e.g :    8:00 AM  9:00 AM 10:00 AM etc.

        'C1Chart1.ChartArea.AxisY.AnnoMethod = C1.Win.C1Chart.AnnotationMethodEnum.ValueLabels
        'Dim dt = startDate
        'While dt <= endDate
        '    C1Chart1.ChartArea.AxisY.ValueLabels.Add(dt.ToOADate(), dt.ToString("hh:00 tt"))
        '    dt = dt.AddHours(1)
        'End While
    End Sub
    Private Function GetData() As List(Of DataItem)
        Dim Data = New List(Of DataItem)
        Dim baseTime = New DateTime(DateTime.Now.Year, DateTime.Now.Month, DateTime.Now.Day, 8, 0, 0)
        Data.Add(New DataItem With {.Task = "Task 1", .StartTime = baseTime, .EndTime = baseTime.AddHours(1)})
        Data.Add(New DataItem With {.Task = "Task 2", .StartTime = baseTime.AddMinutes(45), .EndTime = baseTime.AddHours(2)})
        Data.Add(New DataItem With {.Task = "Task 3", .StartTime = baseTime.AddHours(2), .EndTime = baseTime.AddHours(3)})
        Data.Add(New DataItem With {.Task = "Task 4", .StartTime = baseTime.AddMinutes(2 * 60 + 30), .EndTime = baseTime.AddHours(6)})
        Data.Add(New DataItem With {.Task = "Task 5", .StartTime = baseTime.AddHours(4), .EndTime = baseTime.AddHours(6)})
        Data.Add(New DataItem With {.Task = "Task 6", .StartTime = baseTime.AddHours(7), .EndTime = baseTime.AddHours(8)})
        Return Data
    End Function
End Class
Public Class DataItem
    Public Property Task As String
    Public Property StartTime As DateTime
    Public Property EndTime As DateTime
End Class
